##parameters=label, comment
request=context.REQUEST
response=request.RESPONSE
from Products.PythonScripts.standard import urlencode
url = '%s/stagingarea_view' % context.absolute_url()
catalog = context.portal_catalog
def processQueueCatalog():
    process = getattr(catalog, 'process', None)
    if process:
        items = catalog.getIndexInfo()
        process(len(items))

incremental = request.get('IncrementalPublish', None)

labels=[info.get('label', '').strip() for info in context.getAnnotations()]
processQueueCatalog()
if label.strip() in labels:
    msg = 'the label, %s has already been used.  Please select another.' % str(label)
else:
    msg = context.Title() + ' has been '
    if incremental:
        context.publishLastChanged(label=label, message=comment)
        msg += 'published incrementally.'
    else:
        context.publishStage(label=label, message=comment)
        msg += 'published fully.'
processQueueCatalog()
query = "?" + urlencode(dict(portal_status_message=msg))
response.redirect(url + query)
return url + query
