##############################################################################
#
# Enfold Enterprise Deployment - Remote Deployment of Content
# Copyright (C) 2005 Enfold Systems
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
$Id: __init__.py 732 2005-01-21 19:43:40Z sidnei $
"""

from xmlrpclib import dumps
from cStringIO import StringIO
from eed.common import TempFile

class xmlrpclibMarshaller:

    name = 'data-marshaller'
    storage = TempFile()
    dont_store = ('created', 'modified', 'blob')

    def marshall(self, key, info):
        data = info['data'].copy()
        for k in self.dont_store:
            if data.has_key(k):
                del data[k]
        return self.storage.store(StringIO(dumps((data,))))
