## Script (Python) "ess_getLastChangedPathsSince"
##parameters=date
""" This script is meant to be executed by the stage in the
context of it's public node"""
from Products.CMFCore.utils import getToolByName

pubNodePath = "/".join(context.getPhysicalPath())
ct = getToolByName(context, 'portal_catalog')
brains = ct(path=pubNodePath,
            modified=dict(query=date,
                          range='min'))
paths = [ brain.getPath() for brain in brains
          # avoid the public node itself
          if brain.getPath() != pubNodePath
          # avoid ContentPanel attributes and its subobjects.
          and 'cp_container' not in brain.getPath()
          # avoid portal_factory leftovers
          and 'portal_factory' not in brain.getPath()
          ]
return paths
