from Acquisition import aq_base
from Products.MenuGenerator.MenuTool import registerGenerator
from Products.MenuGenerator.config import *
from Products.MenuGenerator.node import Node
from Products.MenuGenerator.utils import StringExpression
from Products.MenuGenerator.command import Command


from StringIO import StringIO

class ScriptGenerator:
    def getNodeTree(self, context=None, generator=None, **kwargs):
        commandClass = kwargs.get('commandClass', Command)
        tree = Node('menu')
        def commandFactory(commandClass=commandClass):
            return commandClass()
        
        tree = generator(tree=tree, menu_tool=kwargs.get('menu_tool'), commandFactory=commandFactory)

        #XXX should we do attribute scans here?
        
        return tree


        
registerGenerator('script', ScriptGenerator)
