from types import ListType, TupleType

#XXX do this with generators all proper later

class Producer:
    def __init__(self, emitter=None):
        self.emitter = emitter
        self.commands = []
        
    def feed(self, command):
        if type(command) not in [ListType, TupleType]:
            command = (command,)

        for c in command:
            self.commands.append(c)


    def __call__(self, emitter=None):
        e = emitter or self.emitter
        
        for c in self.commands:
            e.emit(c)

        return e.getvalue()
    


    
